ru.bitel.bgbilling.kernel.contract.api.common.service

## Interface ContractTariffService

-     public interface ContractTariffService

- - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method and Description
    --- | ---
    `java.lang.String` | `contractTariffCancelByCustomer(int contractId, int contractTariffId)` Отмена перехода на другой тариф, выполняемая абонентом.
    `java.util.List<java.util.Date>` | `contractTariffChangeAvailableDateList(int contractId, int tariffGroupId, int fromTariffPlanId, int toTariffPlanId)` Получение списка возможных дат для смены тарифа с одного на другой.
    `MapHolder<java.lang.Integer,java.util.List<java.lang.Integer>>` | `contractTariffChangeAvailableMap(int contractId)` Получение привязок с какого (contractTariffId) на какие тарифы (tariffId) можно перейти для указаного договора.
    `java.lang.String` | `contractTariffChangeByCustomer(int contractId, int tariffGroupId, int fromContractTariffId, int toTariffPlanId, java.util.Date fromDate)` Смена тарифа, выполняемая абонентом.
    `void` | `contractTariffDelete(int id)`
    `java.util.List<ContractTariffEntry>` | `contractTariffEntryList(int contractId, java.util.Date date, int entityMid, int entityId)` Получение списка тарифных планов (с периодами действия) договора.
    `ContractTariff` | `contractTariffGet(int id)` Получение тарифного плана (с периодами действия) договора по его ID (contract_tariff.id).
    `ContractTariffGroup` | `contractTariffGroupGet(int contractId)` Возвращает группу тарифов по умолчанию для договора
    `java.util.List<TariffGroup>` | `contractTariffGroupList(int contractId)` Список тарифных групп для редактора тарифа
    `void` | `contractTariffGroupSet(int contractId, int tariffGroupId)` Устанавливает группу тарифов по умолчанию для договора
    `java.util.List<ContractTariff>` | `contractTariffList(int contractId, java.util.Date date, int entityMid, int entityId)`
    `java.util.List<IdTitle>` | `contractTariffListByParam(int contractId, int tariffPlanId, int moduleId, boolean showUsed, boolean useFilter, int tariffGroupId)`
    `int` | `contractTariffUpdate(ContractTariff contractTariff)`
    `void` | `groupOperationSetTariffGroup(java.lang.String contractIds, java.lang.String mode, int tariffPlanId, int tariffGroupId)` Групповая операция установки тарифных групп на тариф договора

- - ### Method Detail

    - #### contractTariffList

          java.util.List<ContractTariff> contractTariffList(int contractId,
                                                            java.util.Date date,
                                                            int entityMid,
                                                            int entityId)
                                                     throws ru.bitel.bgbilling.common.BGException,
                                                            ru.bitel.bgbilling.common.BGMessageException

      Throws:
        `ru.bitel.bgbilling.common.BGException`
        `ru.bitel.bgbilling.common.BGMessageException`

    - #### contractTariffUpdate

          int contractTariffUpdate(ContractTariff contractTariff)
                            throws ru.bitel.bgbilling.common.BGException,
                                   ru.bitel.bgbilling.common.BGMessageException

      Throws:
        `ru.bitel.bgbilling.common.BGException`
        `ru.bitel.bgbilling.common.BGMessageException`

    - #### contractTariffDelete

          void contractTariffDelete(int id)
                             throws ru.bitel.bgbilling.common.BGException,
                                    ru.bitel.bgbilling.common.BGMessageException

      Throws:
        `ru.bitel.bgbilling.common.BGException`
        `ru.bitel.bgbilling.common.BGMessageException`

    - #### contractTariffEntryList

          java.util.List<ContractTariffEntry> contractTariffEntryList(int contractId,
                                                                      java.util.Date date,
                                                                      int entityMid,
                                                                      int entityId)
                                                               throws ru.bitel.bgbilling.common.BGException,
                                                                      ru.bitel.bgbilling.common.BGMessageException

      Получение списка тарифных планов (с периодами действия) договора.
      Parameters:
        `contractId` -
        `date` -
        `entityMid` -
        `entityId` -
      Returns:
      Throws:
        `ru.bitel.bgbilling.common.BGException`
        `ru.bitel.bgbilling.common.BGMessageException`

    - #### contractTariffGet

          ContractTariff contractTariffGet(int id)
                                    throws ru.bitel.bgbilling.common.BGException,
                                           ru.bitel.bgbilling.common.BGMessageException

      Получение тарифного плана (с периодами действия) договора по его ID (contract_tariff.id).
      Parameters:
        `id` - ID из contract_tariff.id
      Returns:
      Throws:
        `ru.bitel.bgbilling.common.BGException`
        `ru.bitel.bgbilling.common.BGMessageException`

    - #### contractTariffChangeAvailableDateList

          java.util.List<java.util.Date> contractTariffChangeAvailableDateList(int contractId,
                                                                               int tariffGroupId,
                                                                               int fromTariffPlanId,
                                                                               int toTariffPlanId)
                                                                        throws ru.bitel.bgbilling.common.BGException,
                                                                               ru.bitel.bgbilling.common.BGMessageException

      Получение списка возможных дат для смены тарифа с одного на другой.
      Parameters:
        `contractId` - ID договора
        `tariffGroupId` - ID группы тарифных планов
        `fromTariffPlanId` - с какого тарифного плана уходим
        `toTariffPlanId` - на какой
      Returns:
      Throws:
        `ru.bitel.bgbilling.common.BGException`
        `ru.bitel.bgbilling.common.BGMessageException`

    - #### contractTariffChangeByCustomer

          java.lang.String contractTariffChangeByCustomer(int contractId,
                                                          int tariffGroupId,
                                                          int fromContractTariffId,
                                                          int toTariffPlanId,
                                                          java.util.Date fromDate)
                                                   throws ru.bitel.bgbilling.common.BGException,
                                                          ru.bitel.bgbilling.common.BGMessageException

      Смена тарифа, выполняемая абонентом.
      Parameters:
        `contractId` - ID договора
        `tariffGroupId` - ID группы тарифных планов
        `fromContractTariffId` - с какого тарифа переходим
        `toTariffPlanId` - на какой тариф переходим
        `fromDate` - с какой даты
      Returns:
      Throws:
        `ru.bitel.bgbilling.common.BGException`
        `ru.bitel.bgbilling.common.BGMessageException`

    - #### contractTariffCancelByCustomer

          java.lang.String contractTariffCancelByCustomer(int contractId,
                                                          int contractTariffId)
                                                   throws ru.bitel.bgbilling.common.BGException,
                                                          ru.bitel.bgbilling.common.BGMessageException

      Отмена перехода на другой тариф, выполняемая абонентом.
      Parameters:
        `contractId` -
        `contractTariffId` -
      Returns:
      Throws:
        `ru.bitel.bgbilling.common.BGException`
        `ru.bitel.bgbilling.common.BGMessageException`

    - #### contractTariffChangeAvailableMap

          MapHolder<java.lang.Integer,java.util.List<java.lang.Integer>> contractTariffChangeAvailableMap(int contractId)
                                                                                                   throws ru.bitel.bgbilling.common.BGException,
                                                                                                          ru.bitel.bgbilling.common.BGMessageException

      Получение привязок с какого (contractTariffId) на какие тарифы (tariffId) можно перейти для указаного договора.
      Parameters:
        `contractId` - ID договора
      Returns:
      Throws:
        `ru.bitel.bgbilling.common.BGException`
        `ru.bitel.bgbilling.common.BGMessageException`

    - #### contractTariffListByParam

          java.util.List<IdTitle> contractTariffListByParam(int contractId,
                                                            int tariffPlanId,
                                                            int moduleId,
                                                            boolean showUsed,
                                                            boolean useFilter,
                                                            int tariffGroupId)
                                                     throws ru.bitel.bgbilling.common.BGException,
                                                            ru.bitel.bgbilling.common.BGMessageException

      Throws:
        `ru.bitel.bgbilling.common.BGException`
        `ru.bitel.bgbilling.common.BGMessageException`

    - #### groupOperationSetTariffGroup

          void groupOperationSetTariffGroup(java.lang.String contractIds,
                                            java.lang.String mode,
                                            int tariffPlanId,
                                            int tariffGroupId)
                                     throws ru.bitel.bgbilling.common.BGException,
                                            ru.bitel.bgbilling.common.BGMessageException

      Групповая операция установки тарифных групп на тариф договора
      Parameters:
        `contractIds` - коды договоров
        `mode` - group или tariff
        `tariffPlanId` - код тарифного плана
        `tariffGroupId` - устанавливаемый код тарифной группы
      Throws:
        `ru.bitel.bgbilling.common.BGException`
        `ru.bitel.bgbilling.common.BGMessageException`

    - #### contractTariffGroupGet

          ContractTariffGroup contractTariffGroupGet(int contractId)
                                              throws ru.bitel.bgbilling.common.BGException,
                                                     ru.bitel.bgbilling.common.BGMessageException

      Возвращает группу тарифов по умолчанию для договора
      Parameters:
        `contractId` -
      Returns:
      Throws:
        `ru.bitel.bgbilling.common.BGException`
        `ru.bitel.bgbilling.common.BGMessageException`

    - #### contractTariffGroupSet

          void contractTariffGroupSet(int contractId,
                                      int tariffGroupId)
                               throws ru.bitel.bgbilling.common.BGException,
                                      ru.bitel.bgbilling.common.BGMessageException

      Устанавливает группу тарифов по умолчанию для договора
      Parameters:
        `contractId` -
        `tariffGroupId` -
      Throws:
        `ru.bitel.bgbilling.common.BGException`
        `ru.bitel.bgbilling.common.BGMessageException`

    - #### contractTariffGroupList

          java.util.List<TariffGroup> contractTariffGroupList(int contractId)
                                                       throws ru.bitel.bgbilling.common.BGException,
                                                              ru.bitel.bgbilling.common.BGMessageException

      Список тарифных групп для редактора тарифа
      Parameters:
        `contractId` -
      Returns:
      Throws:
        `ru.bitel.bgbilling.common.BGException`
        `ru.bitel.bgbilling.common.BGMessageException`